Package org.optaplanner.core.impl.heuristic.selector.entity.nearby

## Class NearEntityNearbyEntitySelector<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.heuristic.selector.AbstractSelector<Solution_>
  - - org.optaplanner.core.impl.heuristic.selector.entity.AbstractEntitySelector<Solution_>
    - - org.optaplanner.core.impl.heuristic.selector.entity.nearby.NearEntityNearbyEntitySelector<Solution_>

- All Implemented Interfaces:
    `Iterable<Object>`, `EventListener`, `ListIterable<Object>`, `EntitySelector<Solution_>`, `IterableSelector<Solution_,​Object>`, `ListIterableSelector<Solution_,​Object>`, `Selector<Solution_>`, `PhaseLifecycleListener<Solution_>`, `SolverLifecycleListener<Solution_>`

      public final class NearEntityNearbyEntitySelector<Solution_>
      extends AbstractEntitySelector<Solution_>

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected EntitySelector<Solution_>` | `childEntitySelector` |
    `protected boolean` | `discardNearbyIndexZero` |
    `protected NearbyDistanceMatrix` | `nearbyDistanceMatrix` |
    `protected NearbyDistanceMeter<?,​?>` | `nearbyDistanceMeter` |
    `protected NearbyRandom` | `nearbyRandom` |
    `protected boolean` | `randomSelection` |
    `protected EntitySelector<Solution_>` | `replayingOriginEntitySelector` |

    - ### Fields inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `logger, phaseLifecycleSupport, workingRandom`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `NearEntityNearbyEntitySelector​(EntitySelector<Solution_> childEntitySelector, EntitySelector<Solution_> originEntitySelector, NearbyDistanceMeter<?,​?> nearbyDistanceMeter, NearbyRandom nearbyRandom, boolean randomSelection)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Iterator<Object>` | `endingIterator()` | If `Selector.isNeverEnding()` is true, then `Iterable.iterator()` will never end.
    `EntityDescriptor<Solution_>` | `getEntityDescriptor()` |
    `long` | `getSize()` | A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
    `boolean` | `isCountable()` | If false, then `Selector.isNeverEnding()` is true.
    `boolean` | `isNeverEnding()` | Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases).
    `Iterator<Object>` | `iterator()` |
    `ListIterator<Object>` | `listIterator()` |
    `ListIterator<Object>` | `listIterator​(int index)` |
    `void` | `phaseEnded​(AbstractPhaseScope<Solution_> phaseScope)` |
    `void` | `phaseStarted​(AbstractPhaseScope<Solution_> phaseScope)` |

    - ### Methods inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `getCacheType, solvingEnded, solvingStarted, stepEnded, stepStarted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.IterableSelector

      `spliterator`

    - ### Methods inherited from interface org.optaplanner.core.impl.phase.event.PhaseLifecycleListener

      `stepEnded, stepStarted`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.Selector

      `getCacheType`

    - ### Methods inherited from interface org.optaplanner.core.impl.solver.event.SolverLifecycleListener

      `solvingEnded, solvingStarted`

- - ### Field Detail

    - #### childEntitySelector

          protected final EntitySelector<Solution_> childEntitySelector

    - #### replayingOriginEntitySelector

          protected final EntitySelector<Solution_> replayingOriginEntitySelector

    - #### nearbyDistanceMeter

          protected final NearbyDistanceMeter<?,​?> nearbyDistanceMeter

    - #### nearbyRandom

          protected final NearbyRandom nearbyRandom

    - #### randomSelection

          protected final boolean randomSelection

    - #### discardNearbyIndexZero

          protected final boolean discardNearbyIndexZero

      See Also:
        Constant Field Values

    - #### nearbyDistanceMatrix

          protected NearbyDistanceMatrix nearbyDistanceMatrix

  - ### Constructor Detail

    - #### NearEntityNearbyEntitySelector

          public NearEntityNearbyEntitySelector​(EntitySelector<Solution_> childEntitySelector,
                                                EntitySelector<Solution_> originEntitySelector,
                                                NearbyDistanceMeter<?,​?> nearbyDistanceMeter,
                                                NearbyRandom nearbyRandom,
                                                boolean randomSelection)

  - ### Method Detail

    - #### phaseStarted

          public void phaseStarted​(AbstractPhaseScope<Solution_> phaseScope)

      Specified by:
        `phaseStarted` in interface `PhaseLifecycleListener<Solution_>`
      Overrides:
        `phaseStarted` in class `AbstractSelector<Solution_>`

    - #### phaseEnded

          public void phaseEnded​(AbstractPhaseScope<Solution_> phaseScope)

      Specified by:
        `phaseEnded` in interface `PhaseLifecycleListener<Solution_>`
      Overrides:
        `phaseEnded` in class `AbstractSelector<Solution_>`

    - #### getEntityDescriptor

          public EntityDescriptor<Solution_> getEntityDescriptor()

      Returns:
        never null

    - #### isCountable

          public boolean isCountable()

      Description copied from interface: `Selector`
      If false, then `Selector.isNeverEnding()` is true.
      Returns:
        true if all the `ValueRange`s are countable (for example a double value range between 1.2 and 1.4 is not countable)

    - #### isNeverEnding

          public boolean isNeverEnding()

      Description copied from interface: `Selector`
      Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases). Is never true when this selector is in shuffled order (which is less scalable but more exact).
      Returns:
        true if the `Iterator.hasNext()` of the `Iterator` created by `Iterable.iterator()` never returns false (except when it's empty).

    - #### getSize

          public long getSize()

      Description copied from interface: `IterableSelector`
      A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
      Returns:
        the approximate number of elements generated by this `Selector`, always `>= 0`

    - #### iterator

          public Iterator<Object> iterator()

    - #### listIterator

          public ListIterator<Object> listIterator()

      Returns:
        never null, see `List.listIterator()`.
      See Also:
        `List.listIterator()`

    - #### listIterator

          public ListIterator<Object> listIterator​(int index)

      Parameters:
        `index` - lower than the size of this `ListIterable`, see `List.listIterator(int)`.
      Returns:
        never null, see `List.listIterator(int)`.
      See Also:
        `List.listIterator()`

    - #### endingIterator

          public Iterator<Object> endingIterator()

      Description copied from interface: `EntitySelector`
      If `Selector.isNeverEnding()` is true, then `Iterable.iterator()` will never end. This returns an ending `Iterator`, that tries to match `Iterable.iterator()` as much as possible, but returns each distinct element only once and returns every element that might possibly be selected and therefore it might not respect the configuration of this `EntitySelector` entirely.
      Returns:
        never null
      See Also:
        `Iterable.iterator()`